/**
 * ORY Keto
 * A cloud native access control server providing best-practice patterns (RBAC, ABAC, ACL, AWS IAM Policies, Kubernetes Roles, ...) via REST APIs.
 *
 * OpenAPI spec version: Latest
 * Contact: hi@ory.sh
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.2.3
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.OryKeto) {
      root.OryKeto = {};
    }
    root.OryKeto.OryAccessControlPolicy = factory(root.OryKeto.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The OryAccessControlPolicy model module.
   * @module model/OryAccessControlPolicy
   * @version Latest
   */

  /**
   * Constructs a new <code>OryAccessControlPolicy</code>.
   * @alias module:model/OryAccessControlPolicy
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>OryAccessControlPolicy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/OryAccessControlPolicy} obj Optional instance to populate.
   * @return {module:model/OryAccessControlPolicy} The populated <code>OryAccessControlPolicy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('actions')) {
        obj['actions'] = ApiClient.convertToType(data['actions'], ['String']);
      }
      if (data.hasOwnProperty('conditions')) {
        obj['conditions'] = ApiClient.convertToType(data['conditions'], {'String': Object});
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('effect')) {
        obj['effect'] = ApiClient.convertToType(data['effect'], 'String');
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('resources')) {
        obj['resources'] = ApiClient.convertToType(data['resources'], ['String']);
      }
      if (data.hasOwnProperty('subjects')) {
        obj['subjects'] = ApiClient.convertToType(data['subjects'], ['String']);
      }
    }
    return obj;
  }

  /**
   * Actions is an array representing all the actions this ORY Access Policy applies to.
   * @member {Array.<String>} actions
   */
  exports.prototype['actions'] = undefined;
  /**
   * Conditions represents a keyed object of conditions under which this ORY Access Policy is active.
   * @member {Object.<String, Object>} conditions
   */
  exports.prototype['conditions'] = undefined;
  /**
   * Description is an optional, human-readable description.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Effect is the effect of this ORY Access Policy. It can be \"allow\" or \"deny\".
   * @member {String} effect
   */
  exports.prototype['effect'] = undefined;
  /**
   * ID is the unique identifier of the ORY Access Policy. It is used to query, update, and remove the ORY Access Policy.
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * Resources is an array representing all the resources this ORY Access Policy applies to.
   * @member {Array.<String>} resources
   */
  exports.prototype['resources'] = undefined;
  /**
   * Subjects is an array representing all the subjects this ORY Access Policy applies to.
   * @member {Array.<String>} subjects
   */
  exports.prototype['subjects'] = undefined;



  return exports;
}));


